=== modified file 'NEWS'
--- NEWS	2008-03-06 01:59:26 +0000
+++ NEWS	2007-05-21 06:19:12 +0000
@@ -1,118 +1,12 @@
+
 What's changed in loggerhead?
 =============================
 
-1.2.1  [06mar2008]
-------------------
-
-    - The changelog view was out of order when not using the revision
-      cache.
-
-1.2  [04mar2008]
-----------------
-
-    - Michael Hudson <michael.hudson@canonical.com> has mostly taken
-      over the maintenance of loggerhead.
-
-    - loggerhead now has a simple test suite -- use 'nosetests' in the
-      loggerhead directory to run it.
-
-    - The rendering performance of pages that display large amounts of
-      text was improved by a factor of 4 or so.
-
-    - loggerhead no longer caches the text of the diffs between
-      revisions.  It rarely helped and wasted a lot of disk space.
-
-    - The layout of most pages was made more "tight" to waste less
-      screen real estate, and some other UI improvements (Kent
-      Gibson).
-
-    - Much dead code was removed.
-
-    - Loggerhead now computes the files changed between revisions only
-      when it needs to know this.  This is a fairly expensive
-      operation in Bazaar, and doing it less massively improves
-      performance and memory usage in some situations.
-
-    - Loggerhead now takes a read lock on the branch being viewed for
-      the duration of each request, which improves performance
-      significantly.
-
-    - Loggerhead no longer uses the corruption-prone Berkely DB-backed
-      shelve module for its caches, and rather (ab)uses a sqlite
-      database instead.
-
-    - The creation of History objects is much faster for large
-      branches (Aaron Bentley).
-
-    - Allow the construction of URLs using revnos and file paths as
-      well as revids and fileids (bug #98826):
-
-      - For changes pages, append the newest revno to display to the
-        URL, like http://.../changes/<revno>
-
-      - For annotate pages, append the revno to display to the URL,
-        followed by the path, like http://.../annotate/<revno>/<path>
-
-      - For file listing and revision pages append the revno to
-        display to the URL, like http://.../files/<revno>
-
-      Loggerhead still generates URLs using revision and file ids for
-      the moment.
-
-    - Many bugs were fixed:
-
-      - Loggerhead does not escape special characters when embedding a
-        revision ID in a URL (bug #88286)
-
-      - Improved robustness in the face of ghosts.
-
-      - Don't crash on displaying a commit with an empty message (bug
-        #86247)
-
-      - codebrowse fails with infinite redirections (James Henstridge,
-        bug #89854)
-
-      - Loggerhead fails to browse revisions that change binary files
-        (James Henstridge, bug #91686)
-
-      - Loggerhead atom feeds expose internal hostname (James
-        Henstridge, bug #93585)
-
-      - loggerhead don't like page break character (0x0C) in text
-        files (bug #113313)
-
-      - codebrowse source listings don't contain line number anchors
-        (bug #98826)
-
-      - only serve up unescaped user content with "Content-Disposition:
-        attachment"
-
-      - viewing the file listing consumes a lot memory (bug #116869)
-
-      - loggerhead can't handle empty branches (bug #119228)
-
-      - upgrading the format of a branch behind loggerhead could make
-        it fail for that branch (bug #118673)
-
-      - Error parsing non-ascii content (bug #117799)
-
-      - Loggerhead failed on whitespace-only commit messages.
-
-      - Links to diffs from within a revision do not work (bug
-        #119422)
-
-      - UTF-8 patches served as ISO-8859-1, fixed by served bundles as
-        application/octet-stream (bug #121336)
-
-      - TurboGears was turning query arguments into unicode, and bzr
-        stopped accepting unicode revids (bug #175228)
-
-
 1.1.1  [24jan2007]
 ------------------
 
     - fix broken inventory page (oops!)
-
+    
     - fix a few rendering problems with kid and safari
 
 
@@ -120,31 +14,31 @@
 ----------------
 
     - new feature to compare two revisions to each other
-
+    
     - inserted text in diffs is now blue instead of green
-
+    
     - fixed to start and stop as a daemon now (use "-f" to run in the
       foreground), and all config is in loggerhead.conf (no need to mess with
       dev.cfg)
-
+      
     - renamed show/hide javascript buttons to expand/collapse, and made them
       much faster
-
+      
     - added an atom-feed link to each branch on the browse page [elliot
       murphy]
-
+      
     - auto-publish feature for multiple branches under a single folder (see
       loggerhead.conf.example)
-
+      
     - added the ability to share cache files per-project instead of just
       per-branch
-
+    
     - added side-by-side diff display for the revision page (which is the
       default), with a button to switch between side-by-side and unified diff
       format
 
     - made caching use file locking, and close cleanly on shutdown
-
+    
     - miscellaneous speed and page-size improvements
 
 

=== modified file 'README.txt'
--- README.txt	2008-03-03 23:10:35 +0000
+++ README.txt	2007-01-24 19:29:58 +0000
@@ -1,83 +1,64 @@
 LOGGERHEAD
 ==========
 
-[ Version 1.2 for Bazaar 1.2 ]
-
-Loggerhead is a web viewer for Bazaar branches.  It can be used to
-navigate a branch history, annotate files, perform searches... all the
-usual things.
-
-To get started, first you need to create a 'loggerhead.conf' file
-specifying the branches you want to view.  A 'loggerhead.conf.example'
-file is included in the source which has comments explaining the
-various options.
-
-Loggerhead can then be started by running::
+[ version 1.1.1 for bazaar 0.13 ]
+
+Loggerhead is a web viewer for bazaar branches.  It can be used to navigate
+a branch history, annotate files, perform searches... all the usual things.
+
+This is a TurboGears (http://www.turbogears.org) project.  It can be
+started by running::
 
     $ ./start-loggerhead.py
-
-This will run loggerhead in the background.  It listens on port 8080
-by default, so go to http://localhost:8080/ in your browser to see the
-list of bublished branches.
-
-To stop Loggerhead, run::
+    
+This will run loggerhead in the background.  To stop it, run::
 
     $ ./stop-loggerhead.py
 
-If you want to view Bazaar branches from your existing Apache
-installation, you'll need to configure Apache to proxy certain
-requests to Loggerhead.  Adding lines like this to you Apache
-configuration is one way to do this::
+If you're not familiar with TurboGears, the simplest way to get running is
+to add the following lines to your apache configuration::
 
     <Location "/branches/">
         ProxyPass http://127.0.0.1:8080/
         ProxyPassReverse http://127.0.0.1:8080/
     </Location>
-
-In the configuration file you can configure projects, and branches per
-project.  The idea is that you could be publishing several (possibly
-unrelated) projects through the same loggerhead instance, and several
-branches for the same project.  See the "loggerhead.conf.example" file
-included with the source.
-
-Although Loggerhead is a TurboGears (http://www.turbogears.org)
-project, don't bother with "dev.cfg" or any of the other TurboGears
-config files.  Loggerhead overrides those values with its own.
-
-A debug and access log are stored in the logs/ folder, relative to
-the location of the start-loggerhead.py script.
-
-You may update the Bazaar branch at any time (for example, from a cron).
-Loggerhead will notice and refresh, and Bazaar uses its own branch
-locking to prevent corruption.
+    
+The config file is "loggerhead.conf".  In there, you can configure projects,
+and branches per project.  The idea is that you could be publishing several
+(possibly unrelated) projects through the same loggerhead instance, and 
+several branches for the same project.
+
+Don't bother with "dev.cfg" or any of the other TurboGears config files.
+Loggerhead overrides those values with its own.
+
+A debug and access log are stored in the logs/ folder.
 
 
 CACHES
 ------
 
-To speed up operations with large branches, loggerhead can be configured
-to create three caches per branch when it first launches:
+To speed up most operations, loggerhead will start creating two caches per
+branch when it first launches:
 
     - a revision data cache
-    - a cache of files changed in a revision
     - a text searching cache
 
-You can put the cache folder anywhere.
-
-The revision data cache and text searching cache will be automatically
-filled once loggerhead starts up.  The caches for a branch with 15,000
-revisions take about four minutes each on a fairly fast machine, but
-mileage may vary.  Once they are built, they update every six hours or
-so but usually finish quickly (or instantly) after the initial creation.
+You can put the cache folder anywhere, but I find that a folder under
+the branch's .bzr/ folder is the simplest place.
+
+The caches for a branch with 10,000 revisions take about 15 minutes each
+on my machine, but YMMV.  Once they are built, they update every six hours
+or so but usually finish quickly (or instantly) after the initial creation.
+Until the revision cache is built, all operations will be slow.
+
+You may update the bazaar branch at any time (for example, from a cron).
+Loggerhead will notice and refresh, and bazaar uses its own branch locking
+to prevent corruption.
 
 
 SUPPORT
 -------
 
-Loggerhead is loosely based on bazaar-webserve, which was loosely
-based on hgweb.  Discussion should take place on the bazaar-dev
-mailing list at bazaar@lists.canonical.com.  You can join the list at
-<https://lists.ubuntu.com/mailman/listinfo/bazaar>.  You don't need to
-subscribe to post, but your first post will be held briefly for manual
-moderation.
+This is loosely based on bazaar-webserve, which was loosely based on hgweb.
+Discussion should take place on the bazaar-dev mailing list.
 

=== modified file 'dev.cfg'
--- dev.cfg	2007-12-12 08:36:51 +0000
+++ dev.cfg	2007-01-14 05:40:40 +0000
@@ -36,10 +36,6 @@
 server.environment="production"
 #autoreload.package="loggerhead"
 
-# We do *not* want our query arguments turned into unicode strings (as
-# we use them for revision/file ids, and these must not be unicode).
-decoding_filter.on = False
-
 # session_filter.on = True
 
 # Set to True if you'd like to abort execution if a controller gets an

=== modified file 'loggerhead.conf.example'
--- loggerhead.conf.example	2008-03-06 07:30:37 +0000
+++ loggerhead.conf.example	2007-06-18 23:07:53 +0000
@@ -5,9 +5,6 @@
 # use this if you're mapping loggerhead within apache via proxy
 #server.webpath = 'http://example.com/branches'
 
-# use this if you want loggerhead to listen to another interface than 127.0.0.1
-# server.socket_host = 'your_hostname_or_ip'
-
 # where's bzrlib?
 # (you only need this if you don't install bzr.)
 #bzrpath = '/Users/robey/code/bzr/bzr'

=== modified file 'loggerhead/branchview.py'
--- loggerhead/branchview.py	2008-04-18 00:33:19 +0000
+++ loggerhead/branchview.py	2007-08-23 15:03:26 +0000
@@ -45,22 +45,20 @@
 
 
 class BranchView (object):
-    def __init__(self, group_name, name, subfolder, absfolder, config,
-                 project_config, root_config):
+    def __init__(self, group_name, name, subfolder, absfolder, config, project_config):
         self._group_name = group_name
         self._name = name
         self._folder = subfolder
         self._absfolder = absfolder
         self._config = config
         self._project_config = project_config
-        self._root_config = root_config
         self.log = logging.getLogger('loggerhead.%s' % (name,))
-
+        
         # branch history
         self._history_lock = threading.RLock()
         self._history = None
         self._closed = False
-
+        
         self.changes = ChangeLogUI(self)
         self.revision = RevisionUI(self)
         self.files = InventoryUI(self)
@@ -68,12 +66,12 @@
         self.download = DownloadUI(self)
         self.atom = AtomUI(self)
         self.bundle = BundleUI(self)
-
+        
         # force history object to be loaded:
         self.get_history()
-
+        
         turbogears.startup.call_on_shutdown.append(self.close)
-
+    
     @with_history_lock
     def close(self):
         # it's important that we cleanly detach the history, so the cache
@@ -82,13 +80,13 @@
         self._history.detach()
         self._history = None
         self._closed = True
-
+            
     config = property(lambda self: self._config)
-
+    
     name = property(lambda self: self._name)
 
     group_name = property(lambda self: self._group_name)
-
+    
     def _get_friendly_name(self):
         name = self._config.get('branch_name', None)
         if name is not None:
@@ -108,9 +106,9 @@
         # try branch-specific config?
         description = self.get_history().get_config().get_user_option('description')
         return description
-
+        
     description = property(_get_description)
-
+    
     def _get_branch_url(self):
         url = self._config.get('url', None)
         if url is not None:
@@ -122,19 +120,13 @@
         # try branch-specific config?
         url = self.get_history().get_config().get_user_option('public_branch')
         return url
-
+        
     branch_url = property(_get_branch_url)
-
+    
     @turbogears.expose()
     def index(self):
         raise HTTPRedirect(self.url('/changes'))
 
-    def get_config_item(self, item, default=None):
-        for conf in self._config, self._project_config, self._root_config:
-            if item in conf:
-                return conf[item]
-        return default
-
     @with_history_lock
     def get_history(self):
         """
@@ -160,14 +152,13 @@
                 _history.use_file_cache(FileChangeCache(_history, cache_path))
                 _history.use_search_index(TextIndex(_history, cache_path))
         return self._history
-
+    
     def check_rebuild(self):
         h = self.get_history()
         if h is not None:
             h.check_rebuild()
-
+    
     def url(self, elements, **kw):
-        "build an url relative to this branch"
         if not isinstance(elements, list):
             elements = [elements]
         if elements[0].startswith('/'):
@@ -175,10 +166,6 @@
         elements = [urllib.quote(x) for x in elements]
         return turbogears.url([ '/' + self.group_name, self.name ] + elements, **kw)
 
-    def context_url(self, elements, **kw):
-        "build an url relative to this branch, bringing along browsing context"
-        return self.url(elements, **util.get_context(**kw))
-
     def last_updated(self):
         h = self.get_history()
         change = h.get_changes([ h.last_revid ])[0]

=== modified file 'loggerhead/changecache.py'
--- loggerhead/changecache.py	2008-02-27 03:36:09 +0000
+++ loggerhead/changecache.py	2007-09-07 16:41:32 +0000
@@ -26,10 +26,13 @@
 """
 
 import cPickle
+import logging
 import os
+import threading
 import time
 
 from loggerhead import util
+from loggerhead.util import decorator
 from loggerhead.lockfile import LockFile
 
 
@@ -104,7 +107,7 @@
     def __init__(self, history, cache_path):
         self.history = history
         self.log = history.log
-
+        
         if not os.path.exists(cache_path):
             os.mkdir(cache_path)
 
@@ -127,7 +130,7 @@
     def close(self):
         self.log.debug('Closing cache file.')
         self._closed = True
-
+    
     @with_lock
     def closed(self):
         return self._closed
@@ -135,7 +138,7 @@
     @with_lock
     def flush(self):
         pass
-
+    
     @with_lock
     def get_changes(self, revid_list):
         """
@@ -188,7 +191,7 @@
         """
         if self.closed() or self.full():
             return
-
+        
         self.log.info('Building revision cache...')
         start_time = time.time()
         last_update = time.time()

=== modified file 'loggerhead/controllers/__init__.py'
--- loggerhead/controllers/__init__.py	2008-04-18 00:33:19 +0000
+++ loggerhead/controllers/__init__.py	2007-06-19 00:27:53 +0000
@@ -20,14 +20,17 @@
 import logging
 import os
 import re
+import sys
+import time
 
 import turbogears
 from turbogears import controllers
+from cherrypy import NotFound
 from configobj import ConfigObj
 
 from loggerhead import util
 from loggerhead.branchview import BranchView
-from loggerhead.history import is_branch
+from loggerhead.history import History, is_branch
 
 log = logging.getLogger("loggerhead.controllers")
 
@@ -40,13 +43,12 @@
 
 
 class Project (object):
-    def __init__(self, name, config, root_config):
+    def __init__(self, name, config):
         self.name = name
         self.friendly_name = config.get('name', name)
         self.description = config.get('description', '')
         self.long_description = config.get('long_description', '')
         self._config = config
-        self._root_config = root_config
         
         self._views = []
         for view_name in config.sections:
@@ -84,9 +86,7 @@
         
     def _add_view(self, view_name, view_config, folder):
         c_view_name = cherrypy_friendly(view_name)
-        view = BranchView(
-            self.name, c_view_name, view_name, folder, view_config,
-            self._config, self._root_config)
+        view = BranchView(self.name, c_view_name, view_name, folder, view_config, self._config)
         self._views.append(view)
         setattr(self, c_view_name, view)
         
@@ -99,8 +99,7 @@
         self._config = config
         for project_name in self._config.sections:
             c_project_name = cherrypy_friendly(project_name)
-            project = Project(
-                c_project_name, self._config[project_name], self._config)
+            project = Project(c_project_name, self._config[project_name])
             self._projects.append(project)
             setattr(self, c_project_name, project)
         

=== modified file 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/annotate_ui.py	2008-02-27 03:35:24 +0000
+++ loggerhead/controllers/annotate_ui.py	2007-08-23 12:18:18 +0000
@@ -17,13 +17,15 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import datetime
 import logging
 import os
 import posixpath
+import textwrap
 import time
 
 import turbogears
-from cherrypy import HTTPError
+from cherrypy import HTTPError, InternalError, session
 
 from loggerhead import util
 

=== modified file 'loggerhead/controllers/atom_ui.py'
--- loggerhead/controllers/atom_ui.py	2008-02-27 03:35:24 +0000
+++ loggerhead/controllers/atom_ui.py	2007-08-30 11:39:10 +0000
@@ -17,6 +17,7 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import cherrypy
 import turbogears
 
 from loggerhead import util

=== modified file 'loggerhead/controllers/bundle_ui.py'
--- loggerhead/controllers/bundle_ui.py	2008-02-27 03:35:24 +0000
+++ loggerhead/controllers/bundle_ui.py	2007-08-23 12:18:18 +0000
@@ -16,11 +16,14 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import os
 import time
 
 import turbogears
 from cherrypy import HTTPRedirect, InternalError, response
 
+from loggerhead import util
+
 
 class BundleUI (object):
 
@@ -51,7 +54,7 @@
                 self.log.exception('Exception fetching bundle')
                 raise InternalError('Could not fetch bundle')
 
-            response.headers['Content-Type'] = 'application/octet-stream'
+            response.headers['Content-Type'] = 'text/plain'
             response.headers['Content-Length'] = len(bundle_data)
             response.body = bundle_data
             self.log.info('/bundle: %r seconds' % (time.time() - z,))

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2008-03-10 04:02:42 +0000
+++ loggerhead/controllers/changelog_ui.py	2007-08-23 12:18:18 +0000
@@ -17,10 +17,11 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import os
 import time
 
 import turbogears
-from cherrypy import InternalError
+from cherrypy import InternalError, session
 
 from loggerhead import util
 
@@ -46,7 +47,7 @@
             else:
                 revid = None
 
-            filter_file_id = kw.get('filter_file_id', None)
+            file_id = kw.get('file_id', None)
             query = kw.get('q', None)
             start_revid = h.fix_revid(kw.get('start_revid', None))
             orig_start_revid = start_revid
@@ -54,8 +55,7 @@
             search_failed = False
 
             try:
-                revid, start_revid, revid_list = h.get_view(
-                    revid, start_revid, filter_file_id, query)
+                revid, start_revid, revid_list = h.get_view(revid, start_revid, file_id, query)
                 kw['start_revid'] = start_revid
                 util.set_context(kw)
 
@@ -70,44 +70,43 @@
                     else:
                         i = None
                     scan_list = revid_list[i:]
-                change_list = scan_list[:pagesize]
-                changes = list(h.get_changes(change_list))
-                h.add_changes(changes)
+                entry_list = scan_list[:pagesize]
+                entries = h.get_changes(entry_list)
+                h.add_changes(entries)
             except:
                 self.log.exception('Exception fetching changes')
                 raise InternalError('Could not fetch changes')
 
-            navigation = util.Container(
-                pagesize=pagesize, revid=revid, start_revid=start_revid,
-                revid_list=revid_list, filter_file_id=filter_file_id,
-                scan_url='/changes', branch=self._branch, feed=True)
+            navigation = util.Container(pagesize=pagesize, revid=revid, start_revid=start_revid, revid_list=revid_list,
+                                        file_id=file_id, scan_url='/changes', branch=self._branch, feed=True)
             if query is not None:
                 navigation.query = query
             util.fill_in_navigation(navigation)
 
+            entries = list(entries)
             # add parent & merge-point branch-nick info, in case it's useful
-            h.get_branch_nicks(changes)
+            h.get_branch_nicks(entries)
 
             # does every change on this page have the same committer?  if so,
             # tell the template to show committer info in the "details block"
             # instead of on each line.
             all_same_author = True
 
-            if changes:
-                author = changes[0].author
-                for e in changes[1:]:
+            if entries:
+                author = entries[0].author
+                for e in entries[1:]:
                     if e.author != author:
                         all_same_author = False
                         break
 
             vals = {
                 'branch': self._branch,
-                'changes': changes,
+                'changes': entries,
                 'util': util,
                 'history': h,
                 'revid': revid,
                 'navigation': navigation,
-                'filter_file_id': filter_file_id,
+                'file_id': file_id,
                 'start_revid': start_revid,
                 'viewing_from': (orig_start_revid is not None) and (orig_start_revid != h.last_revid),
                 'query': query,

=== modified file 'loggerhead/controllers/download_ui.py'
--- loggerhead/controllers/download_ui.py	2008-02-27 03:35:24 +0000
+++ loggerhead/controllers/download_ui.py	2007-08-23 12:18:18 +0000
@@ -17,12 +17,18 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import datetime
 import logging
 import mimetypes
+import os
+import posixpath
+import textwrap
 import time
 
 import turbogears
-from cherrypy import HTTPRedirect, response
+from cherrypy import HTTPRedirect, response, session
+
+from loggerhead import util
 
 
 log = logging.getLogger("loggerhead.controllers")

=== modified file 'loggerhead/controllers/inventory_ui.py'
--- loggerhead/controllers/inventory_ui.py	2008-03-10 04:19:01 +0000
+++ loggerhead/controllers/inventory_ui.py	2007-08-22 22:39:43 +0000
@@ -17,12 +17,15 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import datetime
 import logging
+import os
 import posixpath
+import textwrap
 import time
 
 import turbogears
-from cherrypy import InternalError
+from cherrypy import InternalError, session
 
 from loggerhead import util
 
@@ -64,7 +67,6 @@
                 raise InternalError('Could not fetch changes')
 
             file_id = kw.get('file_id', inv.root.file_id)
-            start_revid = kw.get('start_revid', None)
             sort_type = kw.get('sort', None)
 
             # no navbar for revisions
@@ -100,7 +102,6 @@
                 'history': h,
                 'posixpath': posixpath,
                 'navigation': navigation,
-                'start_revid': start_revid,
             }
             h.flush_cache()
             self.log.info('/inventory %r: %r secs' % (revid, time.time() - z))

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2008-04-18 03:22:47 +0000
+++ loggerhead/controllers/revision_ui.py	2007-08-23 12:18:18 +0000
@@ -17,17 +17,18 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import datetime
+import logging
+import os
+import textwrap
 import time
 
 import turbogears
-from cherrypy import InternalError
+from cherrypy import InternalError, session
 
 from loggerhead import util
 
 
-DEFAULT_LINE_COUNT_LIMIT = 3000
-
-
 class RevisionUI (object):
 
     def __init__(self, branch):
@@ -50,22 +51,20 @@
             else:
                 revid = None
 
-            filter_file_id = kw.get('filter_file_id', None)
+            file_id = kw.get('file_id', None)
             start_revid = h.fix_revid(kw.get('start_revid', None))
             query = kw.get('q', None)
             remember = kw.get('remember', None)
             compare_revid = kw.get('compare_revid', None)
 
             try:
-                revid, start_revid, revid_list = h.get_view(revid, start_revid, filter_file_id, query)
+                revid, start_revid, revid_list = h.get_view(revid, start_revid, file_id, query)
             except:
                 self.log.exception('Exception fetching changes')
                 raise InternalError('Could not fetch changes')
 
-            navigation = util.Container(
-                revid_list=revid_list, revid=revid, start_revid=start_revid,
-                filter_file_id=filter_file_id, pagesize=1,
-                scan_url='/revision', branch=self._branch, feed=True)
+            navigation = util.Container(revid_list=revid_list, revid=revid, start_revid=start_revid, file_id=file_id,
+                                        pagesize=1, scan_url='/revision', branch=self._branch, feed=True)
             if query is not None:
                 navigation.query = query
             util.fill_in_navigation(navigation)
@@ -74,13 +73,6 @@
             # add parent & merge-point branch-nick info, in case it's useful
             h.get_branch_nicks([ change ])
 
-            line_count_limit = int(self._branch.get_config_item(
-                'line_count_limit', DEFAULT_LINE_COUNT_LIMIT))
-            line_count = 0
-            for file in change.changes.modified:
-                for chunk in file.chunks:
-                    line_count += len(chunk.diff)
-
             # let's make side-by-side diff be the default
             side_by_side = not kw.get('unified', False)
             if side_by_side:
@@ -91,7 +83,7 @@
                 'revid': revid,
                 'change': change,
                 'start_revid': start_revid,
-                'filter_file_id': filter_file_id,
+                'file_id': file_id,
                 'util': util,
                 'history': h,
                 'navigation': navigation,
@@ -99,9 +91,6 @@
                 'remember': remember,
                 'compare_revid': compare_revid,
                 'side_by_side': side_by_side,
-                'line_count': line_count,
-                'line_count_limit': line_count_limit,
-                'show_plain_diffs': line_count > line_count_limit,
             }
             h.flush_cache()
             self.log.info('/revision: %r seconds' % (time.time() - z,))

=== modified file 'loggerhead/daemon.py'
--- loggerhead/daemon.py	2008-04-15 03:10:32 +0000
+++ loggerhead/daemon.py	2007-06-18 23:07:53 +0000
@@ -1,6 +1,7 @@
 # daemon code from ASPN
 
 import os
+import sys
 
 
 def daemonize(pidfile, home):
@@ -9,6 +10,7 @@
     background as a daemon.
     """
 
+    UMASK = 0
     WORKDIR = "/"
     REDIRECT_TO = getattr(os, 'devnull', '/dev/null')
     MAXFD = 1024
@@ -18,38 +20,41 @@
     except OSError, e:
         raise Exception("%s [%d]" % (e.strerror, e.errno))
 
-    if pid == 0:      # The first child.
+    if (pid == 0):	# The first child.
         os.setsid()
 
         try:
-            pid = os.fork()     # Fork a second child.
+            pid = os.fork()	# Fork a second child.
         except OSError, e:
             raise Exception, "%s [%d]" % (e.strerror, e.errno)
 
-        if pid == 0:  # The second child.
+        if (pid == 0):	# The second child.
             os.chdir(WORKDIR)
+            os.umask(UMASK)
         else:
-            os._exit(0) # Exit parent (the first child) of the second child.
+            os._exit(0)	# Exit parent (the first child) of the second child.
     else:
-        os._exit(0)     # Exit parent of the first child.
-
-    import resource            # Resource usage information.
-    maxfd = resource.getrlimit(resource.RLIMIT_NOFILE)[1]
-    if (maxfd == resource.RLIM_INFINITY):
-        maxfd = MAXFD
-
-    fd = os.open(REDIRECT_TO, os.O_RDONLY)
-    os.dup2(fd, 0)
-    fd = os.open(REDIRECT_TO, os.O_WRONLY)
-    os.dup2(fd, 1)
-    os.dup2(fd, 2)
-
-    # Iterate through and close all other file descriptors.
-    for fd in range(3, maxfd):
-        try:
-            os.close(fd)
-        except OSError:        # ERROR, fd wasn't open to begin with (ignored)
-            pass
+        os._exit(0)	# Exit parent of the first child.
+
+    #import resource		# Resource usage information.
+    #maxfd = resource.getrlimit(resource.RLIMIT_NOFILE)[1]
+    #if (maxfd == resource.RLIM_INFINITY):
+    #    maxfd = MAXFD
+  
+    # Iterate through and close all file descriptors.
+    #for fd in range(3, maxfd):
+    #    try:
+    #        os.close(fd)
+    #    except OSError:	# ERROR, fd wasn't open to begin with (ignored)
+    #        pass
+
+    # This call to open is guaranteed to return the lowest file descriptor,
+    # which will be 0 (stdin), since it was closed above.
+    #os.open(REDIRECT_TO, os.O_RDWR)	# standard input (0)
+
+    # Duplicate standard input to standard output and standard error.
+    #os.dup2(0, 1)			# standard output (1)
+    #os.dup2(0, 2)			# standard error (2)
 
     f = open(pidfile, 'w')
     f.write('%d\n' % (os.getpid(),))

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2008-06-10 02:03:17 +0000
+++ loggerhead/history.py	2007-09-10 13:41:13 +0000
@@ -27,9 +27,14 @@
 
 
 import bisect
+import cgi
 import datetime
 import logging
+import os
+import posixpath
 import re
+import shelve
+import sys
 import textwrap
 import threading
 import time
@@ -39,31 +44,22 @@
 from loggerhead.util import decorator
 
 import bzrlib
+import bzrlib.annotate
 import bzrlib.branch
 import bzrlib.bundle.serializer
+import bzrlib.decorators
 import bzrlib.diff
 import bzrlib.errors
 import bzrlib.progress
 import bzrlib.revision
+import bzrlib.textfile
 import bzrlib.tsort
 import bzrlib.ui
 
+
 with_branch_lock = util.with_lock('_lock', 'branch')
 
 
-@decorator
-def with_bzrlib_read_lock(unbound):
-    def bzrlib_read_locked(self, *args, **kw):
-        #self.log.debug('-> %r bzr lock', id(threading.currentThread()))
-        self._branch.repository.lock_read()
-        try:
-            return unbound(self, *args, **kw)
-        finally:
-            self._branch.repository.unlock()
-            #self.log.debug('<- %r bzr lock', id(threading.currentThread()))
-    return bzrlib_read_locked
-
-
 # bzrlib's UIFactory is not thread-safe
 uihack = threading.local()
 
@@ -201,38 +197,30 @@
         self = cls()
         self._branch = branch
         self._last_revid = self._branch.last_revision()
-        
+        if self._last_revid is not None:
+            self._revision_graph = branch.repository.get_revision_graph(self._last_revid)
+        else:
+            self._revision_graph = {}
+
         if name is None:
             name = self._branch.nick
         self._name = name
         self.log = logging.getLogger('loggerhead.%s' % (name,))
 
-        graph = branch.repository.get_graph()
-        parent_map = dict(((key, value) for key, value in
-             graph.iter_ancestry([self._last_revid]) if value is not None))
-        
-        self._revision_graph = self._strip_NULL_ghosts(parent_map) 
         self._full_history = []
         self._revision_info = {}
         self._revno_revid = {}
-        if bzrlib.revision.is_null(self._last_revid):
-            self._merge_sort = []
-        else:
-            self._merge_sort = bzrlib.tsort.merge_sort(
-                self._revision_graph, self._last_revid, None, 
-                generate_revno=True)
-
+        self._merge_sort = bzrlib.tsort.merge_sort(self._revision_graph, self._last_revid, generate_revno=True)
         for (seq, revid, merge_depth, revno, end_of_merge) in self._merge_sort:
             self._full_history.append(revid)
             revno_str = '.'.join(str(n) for n in revno)
             self._revno_revid[revno_str] = revid
-            self._revision_info[revid] = (seq, revid, merge_depth, revno_str, 
-                                          end_of_merge)
+            self._revision_info[revid] = (seq, revid, merge_depth, revno_str, end_of_merge)
+
         # cache merge info
         self._where_merged = {}
-        
         for revid in self._revision_graph.keys():
-            if self._revision_info[revid][2] == 0:
+            if not revid in self._full_history:
                 continue
             for parent in self._revision_graph[revid]:
                 self._where_merged.setdefault(parent, set()).add(revid)
@@ -240,39 +228,16 @@
         self.log.info('built revision graph cache: %r secs' % (time.time() - z,))
         return self
 
-    @staticmethod
-    def _strip_NULL_ghosts(revision_graph):
-        """
-        Copied over from bzrlib meant as a temporary workaround deprecated 
-        methods.
-        """
-
-        # Filter ghosts, and null:
-        if bzrlib.revision.NULL_REVISION in revision_graph:
-            del revision_graph[bzrlib.revision.NULL_REVISION]
-        for key, parents in revision_graph.items():
-            revision_graph[key] = tuple(parent for parent in parents if parent
-                in revision_graph)
-        return revision_graph
-
     @classmethod
     def from_folder(cls, path, name=None):
         b = bzrlib.branch.Branch.open(path)
-        b.lock_read()
-        try:
-            return cls.from_branch(b, name)
-        finally:
-            b.unlock()
+        return cls.from_branch(b, name)
 
     @with_branch_lock
     def out_of_date(self):
         # the branch may have been upgraded on disk, in which case we're stale.
-        newly_opened = bzrlib.branch.Branch.open(self._branch.base)
         if self._branch.__class__ is not \
-               newly_opened.__class__:
-            return True
-        if self._branch.repository.__class__ is not \
-               newly_opened.repository.__class__:
+               bzrlib.branch.Branch.open(self._branch.base).__class__:
             return True
         return self._branch.last_revision() != self._last_revid
 
@@ -285,10 +250,6 @@
     def use_search_index(self, index):
         self._index = index
 
-    @property
-    def has_revisions(self):
-        return not bzrlib.revision.is_null(self.last_revid)
-
     @with_branch_lock
     def detach(self):
         # called when a new history object needs to be created, because the
@@ -330,28 +291,17 @@
     def get_revision_history(self):
         return self._full_history
 
-    def get_revids_from(self, revid_list, start_revid):
-        """
-        Yield the mainline (wrt start_revid) revisions that merged each
-        revid in revid_list.
-        """
-        if revid_list is None:
-            revid_list = self._full_history
-        revid_set = set(revid_list)
-        revid = start_revid
-        def introduced_revisions(revid):
-            r = set([revid])
-            seq, revid, md, revno, end_of_merge = self._revision_info[revid]
-            i = seq + 1
-            while i < len(self._merge_sort) and self._merge_sort[i][2] > md:
-                r.add(self._merge_sort[i][1])
-                i += 1
-            return r
-        while 1:
-            if bzrlib.revision.is_null(revid):
-                return
-            if introduced_revisions(revid) & revid_set:
+    def get_revids_from(self, revid_list, revid):
+        """
+        given a list of revision ids, yield revisions in graph order,
+        starting from revid.  the list can be None if you just want to travel
+        across all revisions.
+        """
+        while True:
+            if (revid_list is None) or (revid in revid_list):
                 yield revid
+            if not self._revision_graph.has_key(revid):
+                return
             parents = self._revision_graph[revid]
             if len(parents) == 0:
                 return
@@ -499,16 +449,14 @@
         determine the revision list we're viewing (start_revid, file_id, query)
         and where we are in it (revid).
 
-            - if a query is given, we're viewing query results.
-            - if a file_id is given, we're viewing revisions for a specific
-              file.
-            - if a start_revid is given, we're viewing the branch from a
-              specific revision up the tree.
-
-        these may be combined to view revisions for a specific file, from
-        a specific revision, with a specific search query.
-
-        returns a new (revid, start_revid, revid_list) where:
+        if a query is given, we're viewing query results.
+        if a file_id is given, we're viewing revisions for a specific file.
+        if a start_revid is given, we're viewing the branch from a
+            specific revision up the tree.
+        (these may be combined to view revisions for a specific file, from
+            a specific revision, with a specific search query.)
+
+        returns a new (revid, start_revid, revid_list, scan_list) where:
 
             - revid: current position within the view
             - start_revid: starting revision of this view
@@ -527,7 +475,7 @@
             if revid not in revid_list:
                 # if the given revid is not in the revlist, use a revlist that
                 # starts at the given revid.
-                revid_list = self.get_file_view(revid, file_id)
+                revid_list= self.get_file_view(revid, file_id)
                 start_revid = revid
             return revid, start_revid, revid_list
 
@@ -641,10 +589,6 @@
 
     @with_branch_lock
     def get_changes(self, revid_list):
-        """Return a list of changes objects for the given revids.
-
-        Revisions not present and NULL_REVISION will be ignored.
-        """
         if self._change_cache is None:
             changes = self.get_changes_uncached(revid_list)
         else:
@@ -657,12 +601,6 @@
         for change in changes:
             merge_revids = self.simplify_merge_point_list(self.get_merge_point_list(change.revid))
             change.merge_points = [util.Container(revid=r, revno=self.get_revno(r)) for r in merge_revids]
-            if len(change.parents) > 0:
-                if isinstance(change.parents[0], util.Container):
-                    # old cache stored a potentially-bogus revno
-                    change.parents = [util.Container(revid=p.revid, revno=self.get_revno(p.revid)) for p in change.parents]
-                else:
-                    change.parents = [util.Container(revid=r, revno=self.get_revno(r)) for r in change.parents]
             change.revno = self.get_revno(change.revid)
 
         parity = 0
@@ -672,66 +610,46 @@
 
         return changes
 
-    # alright, let's profile this sucka. (FIXME remove this eventually...)
-    def _get_changes_profiled(self, revid_list):
+    # alright, let's profile this sucka.
+    def _get_changes_profiled(self, revid_list, get_diffs=False):
         from loggerhead.lsprof import profile
         import cPickle
-        ret, stats = profile(self.get_changes_uncached, revid_list)
+        ret, stats = profile(self.get_changes_uncached, revid_list, get_diffs)
         stats.sort()
         stats.freeze()
         cPickle.dump(stats, open('lsprof.stats', 'w'), 2)
         self.log.info('lsprof complete!')
         return ret
 
-    @with_branch_lock
-    @with_bzrlib_read_lock
-    def get_changes_uncached(self, revid_list):
-        revid_list = filter(lambda revid: not bzrlib.revision.is_null(revid),
-                            revid_list)
-        repo = self._branch.repository
-        parent_map = repo.get_graph().get_parent_map(revid_list)
-        # We need to return the answer in the same order as the input,
-        # less any ghosts.
-        present_revids = [revid for revid in revid_list
-                          if revid in parent_map]
-        rev_list = repo.get_revisions(present_revids)
-
-        return [self._change_from_revision(rev) for rev in rev_list]
-
-    def _get_deltas_for_revisions_with_trees(self, revisions):
-        """Produce a list of revision deltas.
+    def _get_deltas_for_revisions_with_trees(self, entries):
+        """Produce a generator of revision deltas.
 
         Note that the input is a sequence of REVISIONS, not revision_ids.
         Trees will be held in memory until the generator exits.
         Each delta is relative to the revision's lefthand predecessor.
-        (This is copied from bzrlib.)
         """
         required_trees = set()
-        for revision in revisions:
-            required_trees.add(revision.revid)
-            required_trees.update([p.revid for p in revision.parents[:1]])
+        for entry in entries:
+            required_trees.add(entry.revid)
+            required_trees.update([p.revid for p in entry.parents[:1]])
         trees = dict((t.get_revision_id(), t) for
                      t in self._branch.repository.revision_trees(required_trees))
         ret = []
         self._branch.repository.lock_read()
         try:
-            for revision in revisions:
-                if not revision.parents:
+            for entry in entries:
+                if not entry.parents:
                     old_tree = self._branch.repository.revision_tree(
                         bzrlib.revision.NULL_REVISION)
                 else:
-                    old_tree = trees[revision.parents[0].revid]
-                tree = trees[revision.revid]
+                    old_tree = trees[entry.parents[0].revid]
+                tree = trees[entry.revid]
                 ret.append(tree.changes_from(old_tree))
             return ret
         finally:
             self._branch.repository.unlock()
 
-    def _change_from_revision(self, revision):
-        """
-        Given a bzrlib Revision, return a processed "change" for use in
-        templates.
-        """
+    def entry_from_revision(self, revision):
         commit_time = datetime.datetime.fromtimestamp(revision.timestamp)
 
         parents = [util.Container(revid=r, revno=self.get_revno(r)) for r in revision.parent_ids]
@@ -746,10 +664,31 @@
             'short_comment': short_message,
             'comment': revision.message,
             'comment_clean': [util.html_clean(s) for s in message],
-            'parents': revision.parent_ids,
+            'parents': parents,
         }
         return util.Container(entry)
 
+    @with_branch_lock
+    def get_changes_uncached(self, revid_list):
+        # Because we may loop and call get_revisions multiple times (to throw
+        # out dud revids), we grab a read lock.
+        self._branch.lock_read()
+        try:
+            while True:
+                try:
+                    rev_list = self._branch.repository.get_revisions(revid_list)
+                except (KeyError, bzrlib.errors.NoSuchRevision), e:
+                    # this sometimes happens with arch-converted branches.
+                    # i don't know why. :(
+                    self.log.debug('No such revision (skipping): %s', e)
+                    revid_list.remove(e.revision)
+                else:
+                    break
+
+            return [self.entry_from_revision(rev) for rev in rev_list]
+        finally:
+            self._branch.unlock()
+
     def get_file_changes_uncached(self, entries):
         delta_list = self._get_deltas_for_revisions_with_trees(entries)
 
@@ -770,11 +709,11 @@
 
     @with_branch_lock
     def get_change_with_diff(self, revid, compare_revid=None):
-        change = self.get_changes([revid])[0]
+        entry = self.get_changes([revid])[0]
 
         if compare_revid is None:
-            if change.parents:
-                compare_revid = change.parents[0].revid
+            if entry.parents:
+                compare_revid = entry.parents[0].revid
             else:
                 compare_revid = 'null:'
 
@@ -782,10 +721,11 @@
         rev_tree2 = self._branch.repository.revision_tree(revid)
         delta = rev_tree2.changes_from(rev_tree1)
 
-        change.changes = self.parse_delta(delta)
-        change.changes.modified = self._parse_diffs(rev_tree1, rev_tree2, delta)
-
-        return change
+        entry.changes = self.parse_delta(delta)
+
+        entry.changes.modified = self._parse_diffs(rev_tree1, rev_tree2, delta)
+
+        return entry
 
     @with_branch_lock
     def get_file(self, file_id, revid):
@@ -838,7 +778,7 @@
                     diff = buffer.getvalue()
             else:
                 diff = ''
-            out.append(util.Container(filename=rich_filename(new_path, kind), file_id=fid, chunks=self._process_diff(diff), raw_diff=diff))
+            out.append(util.Container(filename=rich_filename(new_path, kind), file_id=fid, chunks=self._process_diff(diff)))
 
         return out
 
@@ -978,10 +918,14 @@
 
         file_revid = self.get_inventory(revid)[file_id].revision
         oldvalues = None
-        tree = self._branch.repository.revision_tree(file_revid)
+
+        # because we cache revision metadata ourselves, it's actually much
+        # faster to call 'annotate_iter' on the weave directly than it is to
+        # ask bzrlib to annotate for us.
+        w = self._branch.repository.weave_store.get_weave(file_id, self._branch.repository.get_transaction())
+
         revid_set = set()
-
-        for line_revid, text in tree.annotate_iter(file_id):
+        for line_revid, text in w.annotate_iter(file_revid):
             revid_set.add(line_revid)
             if self._BADCHARS_RE.match(text):
                 # bail out; this isn't displayable text
@@ -989,11 +933,10 @@
                                      text='(This is a binary file.)',
                                      change=util.Container())
                 return
-        change_cache = dict([(c.revid, c) \
-                for c in self.get_changes(list(revid_set))])
+        change_cache = dict([(c.revid, c) for c in self.get_changes(list(revid_set))])
 
         last_line_revid = None
-        for line_revid, text in tree.annotate_iter(file_id):
+        for line_revid, text in w.annotate_iter(file_revid):
             if line_revid == last_line_revid:
                 # remember which lines have a new revno and which don't
                 status = 'same'
@@ -1023,3 +966,4 @@
         s = StringIO()
         bzrlib.bundle.serializer.write_bundle(self._branch.repository, revid, compare_revid, s)
         return s.getvalue()
+

=== added file 'loggerhead/history2.py'
--- loggerhead/history2.py	1970-01-01 00:00:00 +0000
+++ loggerhead/history2.py	2007-06-25 10:16:34 +0000
@@ -0,0 +1,194 @@
+"""Extract data suitable for web presentation from Bazaar branches.
+
+The module is the interface between Loggerhead and bzrlib.  Other code in
+Loggerhead should not use bzrlib APIs, and functions and methods in this
+module should not return bzrlib data types.
+
+The core method is `History.getRevisionInfo`.  This method is meant to be
+cheap, so you should not worry about calling it multiple times with the same
+argument or calling it just to retreive a subset of the information it
+returns.
+
+Revisions are described using good old bzrlib revision ids.
+
+Revision ids, file ids, file names and file paths are always utf-8 encoded 8
+bit strings.
+"""
+
+class FileDelta(object):
+    """Information about how an inventory entry changed in a revision.
+
+    All attribute names are fairly self explanatory.  The ``*_parent`` fields
+    are the file id of the parent or ``None`` for the root.
+
+    :ivar file_id:
+    :ivar old_path:
+    :ivar new_path:
+    :ivar old_name:
+    :ivar new_name:
+    :ivar old_parent:
+    :ivar new_parent:
+    :ivar old_kind:
+    :ivar new_kind:
+    :ivar content_change:
+    :type content_change: ``bool``
+    :ivar execute_change: A boolean reflecting the new state if it changed, or
+                          ``None`` if it did not.
+    :type execute_change: ``bool`` or ``None``
+    """
+
+
+class FileChanges(object):
+    """Contains information about which files changed in a revision.
+
+    Note that the 'files changed' information is relative to left-most parent
+    by default, as in 'bzr log -v'.
+
+    :ivar deltas: A list of `FileDelta` objects.
+    :ivar fileset: ``set(d.file_id for d in self.deltas)``, but cached.
+    """
+
+class RevisionInfo(object):
+    """Contains all the immutable information Loggerhead needs about a
+    particular revision.
+
+    :ivar revid: Obvious.
+    :ivar date: The date and time this revision was committed.
+    :type date: ``datetime.datetime``
+    :ivar committer: The committer.
+    :type committer: utf-8 encoded ``str``
+    :ivar revprops: The branch properties.
+    :type revprops: A dictionary mapping ``str``\ s to ``str``\ s (both utf-8
+                    encoded).
+    :ivar message: The commit message of this revision.
+    :type message: utf-8 encoded ``str``
+    :ivar parents: The list of the revids of the revision's parents.
+    """
+
+class BranchRevisionInfo(object):
+    """Contains all the mutable information Loggerhead needs about a
+    particular revision, and points to the immutable data.
+
+    :ivar revno: The dotted revno of this revision in this branch.
+    :type revno: ``str``
+    :ivar where_merged: The list of revids that have this revision as a
+                        parent.
+    :ivar info: The corresponding `RevisionInfo`.
+    """
+
+class FileEntry(object):
+    """An entry in the list returned by `getFileList`.
+
+    :ivar path: The path of the object in the revision passed to
+                `getFileList`.
+    :ivar fileid: Obvious.
+    :ivar kind: one of ``'file'``, ``'executable'``, ``'link'`` or
+                ``'directory'``.
+    :type kind: ``str``
+    :ivar last_changed_revid: The revid of the revision in which this path
+                              last changed.  Not that this is recursive,
+                              i.e. the last_changed_revid for a directory is
+                              the revid in which the directory or anything
+                              contained in in changed.x
+    :ivar size: The size of this object in this revision in bytes.
+    :type size: ``int``
+    """
+
+class History(object):
+    """Provide the information loggerhead needs about a bzrlib Branch.
+
+    An instance of this class is effectively a wrapper around a
+    `bzrlib.branch.Branch` that translates the information provided by bzrlib
+    into a form convenient for use in loggerhead.
+
+    :ivar last_revision: The revid of the tip of the branch.
+    """
+
+    @classmethod
+    def fromBranch(cls, branch):
+        """Create and initialize a `History` object from a
+        `bzrlib.branch.Branch`.
+        """
+
+    def outOfDate(self):
+        """Decide whether this History object is still current.
+
+        At least to start with, an out of date History object should be thrown
+        away and a fresh one created.
+        """
+
+    def getRevisionInfo(self, revid):
+        """Find the `BranchRevisionInfo` object for a given revision id.
+
+        This operation is to be thought of as 'cheap', which is to say that
+        you should not worry about calling it repeatedly with the same
+        argument or about calling it just to retrieve a subset of the
+        information it includes.
+
+        :param revid: a revision id.
+        :returns: a `BranchRevisionInfo` object or ``None`` if the given
+                  revision id does not exist in the branch.
+        """
+
+    def getChanges(self, revid, other_revid=None):
+        """Find the `FileChanges` object between two revision.
+
+        :param revid: A revision id.
+        :param other_revid: The revision id to compare against.  If ``None``
+                            or not given, compare against the leftmost parent
+                            of ``revid``.
+        :returns: The corresponding `FileChanges` object.
+        """
+
+    # There will need to be some more methods here to allow searching for
+    # revisions by date, committer, commit message, etc...
+
+    def getDiff(self, revidA, revidB):
+        """Compute the diff between two revisions.
+
+        Not sure what this will return yet, probably something similar to but
+        more structured than the 'chunks' loggerhead already works with.
+        """
+
+    def getDirList(self, fileid, revid):
+        """List the files in the given directory as of the given revision.
+
+        :return: a list of `FileEntry` objects.
+        """
+
+    def getFileAnnotation(self, fileid, revid):
+        """Annotate the given file.
+
+        Not sure what this should return, mostly likely a list of
+        (revid-or-None, line contents) (and ``None`` for a binary file).
+        """
+
+    def getFileText(self, fileid, revid):
+        """Fetch the contents of a file at a particular revision.
+
+        :returns: (filename, data)
+        :rtype: ``(str, str)``
+        """
+
+    def getBundle(self, revid, compare_revid=None):
+        """Return a bundle for this revision.
+
+        Relative to compare_revid, or left-most parent if this is not supplied
+        or None.
+
+        :return: A bundle (in a string).
+        """
+
+    def normalizeRevivionSpec(self, revspec):
+        """Convert a revid or revno or 'head' to a revid.
+
+        :returns: a revision id.
+        """
+
+    def normalizeFileArguments(self, revid, fileid, filepath):
+        """Handle various ways of specifying a file in the branch.
+
+        One of ``fileid`` and ``filepath`` should be None.
+
+        :returns: (fileid, filepath)
+        """

=== added file 'loggerhead/json.py'
--- loggerhead/json.py	1970-01-01 00:00:00 +0000
+++ loggerhead/json.py	2006-12-11 06:44:19 +0000
@@ -0,0 +1,12 @@
+# This module provides helper functions for the JSON part of your
+# view, if you are providing a JSON-based API for your app.
+
+# Here's what most rules would look like:
+# @jsonify.when("isinstance(obj, YourClass)")
+# def jsonify_yourclass(obj):
+#     return [obj.val1, obj.val2]
+# The goal is to break your objects down into simple values:
+# lists, dicts, numbers and strings
+
+from turbojson.jsonify import jsonify
+

=== modified file 'loggerhead/lockfile.py'
--- loggerhead/lockfile.py	2008-02-27 03:36:09 +0000
+++ loggerhead/lockfile.py	2007-01-14 01:20:39 +0000
@@ -35,7 +35,7 @@
     lock may be acquired multiple times by the same thread, as long as it's
     released an equal number of times.  unlike threading.Lock, this lock can
     be used across processes.
-
+    
     this uses os.open(O_CREAT|O_EXCL), which apparently works even on windows,
     but will not work over NFS, if anyone still uses that.  so don't put the
     cache folder on an NFS server...
@@ -50,7 +50,7 @@
             # remove stale locks left over from a previous run
             if time.time() - os.stat(filename).st_mtime > MAX_STALE_TIME:
                 os.remove(filename)
-
+    
     @with_lock
     def _try_acquire(self):
         if self._count > 0:
@@ -63,7 +63,7 @@
             return True
         except OSError:
             return False
-
+    
     def acquire(self):
         # try over and over, sleeping on exponential backoff with an upper limit of about 5 seconds
         pause = 0.1

=== modified file 'loggerhead/lsprof.py'
--- loggerhead/lsprof.py	2008-02-27 03:36:09 +0000
+++ loggerhead/lsprof.py	2006-12-15 01:14:05 +0000
@@ -36,7 +36,7 @@
         for pp in _g_threadmap.values():
             pp.disable()
         threading.setprofile(None)
-
+    
     threads = {}
     for tid, pp in _g_threadmap.items():
         threads[tid] = Stats(pp.getstats(), {})
@@ -112,7 +112,7 @@
         self.out_file = None
 
     def output(self, out_file):
-        self.out_file = out_file
+        self.out_file = out_file        
         print >> out_file, 'events: Ticks'
         self._print_summary()
         for entry in self.data:

=== added file 'loggerhead/model.py'
--- loggerhead/model.py	1970-01-01 00:00:00 +0000
+++ loggerhead/model.py	2006-12-11 06:44:19 +0000
@@ -0,0 +1,10 @@
+from sqlobject import *
+
+from turbogears.database import PackageHub
+
+hub = PackageHub("loggerhead")
+__connection__ = hub
+
+# class YourDataClass(SQLObject):
+#     pass
+

=== modified file 'loggerhead/release.py'
--- loggerhead/release.py	2008-03-06 01:59:26 +0000
+++ loggerhead/release.py	2007-01-24 19:29:58 +0000
@@ -1,6 +1,6 @@
 # Release information about loggerhead
 
-version = "1.2.1"
+version = "1.1.1-0.13"
 
 description = "Loggerhead is a web viewer for projects in bazaar."
 
@@ -8,5 +8,5 @@
 email = "robey@lag.net"
 
 license = "GPL"
-url = "http://launchpad.net/loggerhead"
-download_url = "https://launchpad.net/loggerhead/trunk/1.2/+download/loggerhead-1.2.tar.gz"
+url = "http://www.lag.net/loggerhead/"
+download_url = "http://www.lag.net/loggerhead/download/loggerhead-1.1.1-0.13.tar.gz"

=== modified file 'loggerhead/static/css/style.css'
--- loggerhead/static/css/style.css	2008-04-18 00:00:58 +0000
+++ loggerhead/static/css/style.css	2007-07-04 12:08:51 +0000
@@ -216,7 +216,7 @@
 }
 
 .log-entries .revision-header {
-    font-size: 1.0em;
+    font-size: normal;
 }
 
 .log-entries .revision-header td {
@@ -315,6 +315,10 @@
     padding-bottom: 2px;
 }
 
+.revision-info table td.date {
+    font-family: monospace;
+}
+
 .revision-info table td.description {
     font-family: monospace;
 }
@@ -450,12 +454,6 @@
     background-color: #dee7ec;
 }*/
 
-pre.diff-plain {
-    border: 1px solid #8cacbb;
-    background-color: #f4f5f8;
-    padding: 1em;
-    font-size: smaller;
-}
 
 /* ----- file inventory ----- */
 
@@ -505,8 +503,6 @@
     font-family: monospace;
     font-size: smaller;
     width: 5em;
-    line-height: 1em;
-    vertical-align: bottom;
 }
 
 .inventory td.revision {
@@ -517,7 +513,7 @@
 
 .inventory td.date {
     padding-right: 1em;
-    width: 11em;
+    width: 10em;
 }
 
 .inventory td.changes-link {

=== modified file 'loggerhead/templates/annotate.kid'
--- loggerhead/templates/annotate.kid	2008-03-30 23:24:49 +0000
+++ loggerhead/templates/annotate.kid	2007-06-21 16:39:33 +0000
@@ -14,7 +14,7 @@
 	<div class="links">
 	    <div> <b>&#8594;</b> <a href="${branch.url([ '/files', revid ], **util.get_context(clear=1))}"> browse files </a> </div>
 	    <div> <b>&#8594;</b> <a href="${branch.url('/revision', **util.get_context(clear=1, start_revid=revid))}"> view revision </a> </div>
-	    <div> <b>&#8594;</b> <a href="${branch.url('/changes', **util.get_context(clear=1, start_revid=revid, filter_file_id=file_id))}"> view changes to this file </a> </div>
+	    <div> <b>&#8594;</b> <a href="${branch.url('/changes', **util.get_context(clear=1, start_revid=revid, file_id=file_id))}"> view changes to this file </a> </div>
 	    <div> <b>&#8594;</b> <a href="${branch.url([ '/download', revid, file_id, filename ])}"> download file </a> </div>
 	</div>
 </h1>
@@ -30,8 +30,8 @@
         <tr py:for="line in contents" class="parity${line.parity}">
             <td class="lineno ${line.status}"><a name="L${line.lineno}"> ${line.lineno} </a></td>
             <td class="revno ${line.status}">
-                <a py:if="line.status=='changed'" href="${branch.url('/revision', **util.get_context(clear=1, start_revid=line.change.revid, filter_file_id=file_id))}"
-                    title="${line.change.revno} by ${util.hide_email(line.change.author)}, ${util.date_time(line.change.date)}})">${util.trunc(line.change.revno)}</a>
+                <a py:if="line.status=='changed'" href="${branch.url('/revision', **util.get_context(clear=1, start_revid=line.change.revid, file_id=file_id))}"
+                    title="${line.change.revno} by ${util.hide_email(line.change.author)}, on ${line.change.date.strftime('%d %b %Y %H:%M')} (${util.ago(line.change.date)})">${util.trunc(line.change.revno)}</a>
             </td>
             <td class="text ${line.status}"> ${line.text} </td>
         </tr>

=== modified file 'loggerhead/templates/browse.kid'
--- loggerhead/templates/browse.kid	2008-03-09 00:22:47 +0000
+++ loggerhead/templates/browse.kid	2007-06-08 11:52:33 +0000
@@ -34,7 +34,7 @@
             <tr>
             <td class="name"> <a href="${tg.url([ '/' + project.name, view.name ])}">${view.friendly_name}</a> </td>
             <td class="description"> ${view.description} </td>
-            <td class="last-update"> ${view.get_history().has_revisions and util.approximatedate(view.last_updated()) or "(no revisions)"} </td>
+            <td class="last-update"> ${view.get_history().last_revid and util.ago(view.last_updated()) or "(no revisions)"} </td>
             <td class="feed">
                 <a href="${tg.url([ '/' + project.name, view.name, 'atom' ])}" title="atom feed">
                     <img src="${tg.url('/static/images/feed-icon-16x16.gif')}" alt="atom feed" />

=== modified file 'loggerhead/templates/changelog.kid'
--- loggerhead/templates/changelog.kid	2008-03-10 04:22:42 +0000
+++ loggerhead/templates/changelog.kid	2007-06-26 05:34:28 +0000
@@ -14,22 +14,7 @@
         <a href="${branch.url([ '/annotate', revid ], **util.get_context(file_id=file_id))}" title="Annotate ${filename}">${filename}</a>
     </span>
     
-    <span py:def="file_diff_link(revid, filename)">
-        <a href="javascript:diff_url('${branch.context_url([ '/revision', revid ]) + '#' + filename}')"
-           title="View diff for ${filename}">${filename}</a>
-    </span>
-    
     ${use_collapse_buttons()}
-
-    <script type="text/javascript"> <!--
-    function diff_url(url) {
-        if (document.cookie.indexOf('diff=unified') >= 0) {
-            this.location.href = url + "-u";
-        } else {
-            this.location.href = url + "-s";
-        }
-    }
-    // --> </script>
 </head>
 
 <body onload="javascript:sortCollapseElements();">
@@ -37,7 +22,7 @@
 ${navbar()}
 
 <h1> <span class="branch-name">${branch.friendly_name}</span> : changes
-<span py:if="filter_file_id"> to <span class="filename">${history.get_path(revid, filter_file_id)}</span></span>
+<span py:if="file_id"> to <span class="filename">${history.get_path(revid, file_id)}</span></span>
 <span py:if="viewing_from"> from ${history.get_revno(start_revid)} </span>
 <span py:if="query"> matching "${query}"</span>
 </h1>
@@ -77,7 +62,7 @@
             <span py:strip="True" py:if="not all_same_author">
                 <td class="author"> ${util.trunc(util.hide_email(entry.author), 20)} </td>
             </span>
-            <td class="date"> ${util.approximatedate(entry.date)} </td>
+            <td class="date"> ${entry.date.strftime('%Y-%m-%d, %H:%M')} &nbsp; (${util.ago(entry.date)}) </td>
             <td class="inventory-link"> 
                 <a href="${branch.url([ '/files', entry.revid ])}"
                     title="Files at revision ${entry.revno}"> files</a>
@@ -98,9 +83,9 @@
                 <tr py:if="len(entry.parents) > 1">
                     <th class="parents"> merged from: </th>
                     <td class="parents">
-                        <span py:for="parent in entry.parents[1:]">
-                            ${loglink(parent.revid, parent.revno + util.if_present(' (%s)', parent.branch_nick))} <br />
-                        </span>
+                        <span py:for="parent in entry.parents"><span py:if="parent.revid != entry.parents[0].revid">
+                            ${loglink(parent.revid, '(' + parent.revno + util.if_present(' %s', parent.branch_nick) + ')')} <br />
+                        </span></span>
                     </td>
                 </tr>
                 <span py:strip="True" py:if="all_same_author">
@@ -130,7 +115,8 @@
                 <tr py:if="entry.changes.modified">
                     <th class="files"> files modified: </th>
                     <td class="files"> <span py:for="item in entry.changes.modified">
-                        <span class="filename">${file_diff_link(entry.revid, item.filename)}</span>
+                        <span class="filename">${file_link(item.filename, item.file_id, entry.revid)}</span> &nbsp;
+                        <a href="${branch.url([ '/revision', entry.revid ], **util.get_context()) + '#' + item.filename}" class="jump">&#8594; diff</a>
                         <br />
                     </span> </td>
                 </tr>

=== modified file 'loggerhead/templates/inventory.kid'
--- loggerhead/templates/inventory.kid	2008-03-10 04:22:42 +0000
+++ loggerhead/templates/inventory.kid	2007-06-25 06:44:52 +0000
@@ -12,9 +12,9 @@
 
 <h1> <span class="branch-name">${branch.friendly_name}</span> : files for revision ${change.revno}
 	<div class="links">
-	    <div> <b>&#8594;</b> <a href="${branch.context_url('/revision', clear=1, start_revid=revid)}">
+	    <div> <b>&#8594;</b> <a href="${branch.url('/revision', **util.get_context(clear=1, start_revid=revid))}">
 	        view revision </a> </div>
-	    <div> <b>&#8594;</b> <a href="${branch.context_url('/changes', clear=1, start_revid=revid)}">
+	    <div> <b>&#8594;</b> <a href="${branch.url('/changes', **util.get_context(clear=1, start_revid=revid))}">
 	        view branch changes </a> </div>
 	</div>
 </h1>
@@ -28,7 +28,7 @@
         </tr>
         <tr>
             <th class="date">date:</th>
-            <td class="date"> ${util.date_time(change.date)} </td>
+            <td class="date"> ${change.date.strftime('%d %b %Y %H:%M')} </td>
         </tr>
 
         <tr py:if="len(change.merge_points) > 0">
@@ -62,35 +62,36 @@
 <table class="inventory" width="100%">
     <tr class="header">
         <th class="permissions"> Permissions </th>
-        <th> <a href="${branch.context_url([ '/files', revid ], sort='filename')}">Filename</a> </th>
+        <th> <a href="${branch.url([ '/files', revid ], **util.get_context(sort='filename'))}">Filename</a> </th>
         <th> Latest Rev </th>
-        <th> <a href="${branch.context_url([ '/files', revid ], sort='date')}">Last Changed</a> </th>
-        <th> <a href="${branch.context_url([ '/files', revid ], sort='size')}">Size</a> </th>
+        <th> <a href="${branch.url([ '/files', revid ], **util.get_context(sort='date'))}">Last Changed</a> </th>
+        <th> <a href="${branch.url([ '/files', revid ], **util.get_context(sort='size'))}">Size</a> </th>
         <th>  </th>
         <th>  </th>
     </tr>
     
     <tr class="parity1" py:if="updir">
         <td class="permissions">drwxr-xr-x</td>
-        <td class="filename directory"><a href="${branch.context_url([ '/files', revid ], file_id=updir_file_id)}"> (up) </a></td>
+        <td class="filename directory"><a href="${branch.url([ '/files', revid ],
+            **util.get_context(file_id=updir_file_id))}"> (up) </a></td>
         <td> </td> <td> </td> <td> </td> <td> </td>
     </tr>
 
     <tr py:for="file in filelist" class="parity${file.parity}">
         <td class="permissions"> ${util.fake_permissions(file.kind, file.executable)} </td>
         <td class="filename ${file.kind}">
-            <a py:if="file.kind=='directory'" href="${branch.context_url([ '/files', revid ],
-                file_id=file.file_id)}">${file.filename}/</a>
+            <a py:if="file.kind=='directory'" href="${branch.url([ '/files', revid ],
+                **util.get_context(file_id=file.file_id))}">${file.filename}/</a>
             <span py:if="file.kind=='symlink'">${file.filename}@</span>
-            <a py:if="file.kind=='file'" href="${branch.context_url([ '/annotate', revid ],
-                file_id=file.file_id)}" title="Annotate ${file.filename}">${file.filename}</a>
+            <a py:if="file.kind=='file'" href="${branch.url([ '/annotate', revid ],
+                **util.get_context(file_id=file.file_id))}" title="Annotate ${file.filename}">${file.filename}</a>
         </td>
-        <td class="revision"> ${revision_link(file.revid, util.trunc(file.change.revno, 15), **util.get_context(start_revid=file.revid, filter_file_id=file.file_id))} </td>
-        <td class="date"> ${util.date_time(file.change.date)} </td>
+        <td class="revision"> ${revision_link(file.revid, util.trunc(file.change.revno, 15), **util.get_context(start_revid=file.revid, file_id=file.file_id))} </td>
+        <td class="date"> ${file.change.date.strftime('%Y-%m-%d, %H:%M')} </td>
         <td class="size"> <span py:if="file.kind=='file'"> ${util.human_size(file.size)} </span></td>
         <td class="changes-link"> 
-            <a href="${branch.context_url('/changes', start_revid=start_revid, file_id=file.file_id)}"
-               title="Changes affecting ${file.filename}"> changes </a>
+            <a href="${branch.url('/changes', **util.get_context(start_revid=file.revid, file_id=file.file_id))}"
+               title="Changes affecting ${file.filename} up to revision ${file.change.revno}"> changes </a>
         </td>
         <td class="download-link">
             <a href="${branch.url([ '/download', file.revid, file.file_id, file.filename ])}"

=== modified file 'loggerhead/templates/master.kid'
--- loggerhead/templates/master.kid	2008-03-07 10:16:51 +0000
+++ loggerhead/templates/master.kid	2007-01-24 19:17:40 +0000
@@ -1,106 +1,107 @@
-<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
-<?python import sitetemplate ?>
-<html xmlns="http://www.w3.org/1999/xhtml" xmlns:py="http://purl.org/kid/ns#" py:extends="sitetemplate">
-
-<head py:match="item.tag=='{http://www.w3.org/1999/xhtml}head'" py:attrs="item.items()">
-    <meta content="text/html; charset=UTF-8" http-equiv="content-type" py:replace="''"/>
-    <title py:replace="''">Your title goes here</title>
-    <meta py:replace="item[:]"/>
-    <style type="text/css" media="screen">
-@import "${tg.url('/static/css/style.css')}";
-    </style>
-
-<!-- !define common navbar -->
-<span py:def="navbar()" py:strip="True">
-    <!-- !requires: ${navigation: start_revid, revid, revid_list, pagesize, buttons, scan_url}, ${branch}, ${history} -->
-    <div class="bar" py:if="navigation is not None">
-        <!-- form must go OUTSIDE the table, or safari will add extra padding :( -->
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<?python import sitetemplate ?>
+<html xmlns="http://www.w3.org/1999/xhtml" xmlns:py="http://purl.org/kid/ns#" py:extends="sitetemplate">
+
+<head py:match="item.tag=='{http://www.w3.org/1999/xhtml}head'" py:attrs="item.items()">
+    <meta content="text/html; charset=UTF-8" http-equiv="content-type" py:replace="''"/>
+    <title py:replace="''">Your title goes here</title>
+    <meta py:replace="item[:]"/>
+    <style type="text/css" media="screen">
+@import "${tg.url('/static/css/style.css')}";
+    </style>
+
+<!-- !define common navbar -->
+<span py:def="navbar()" py:strip="True">
+    <!-- !requires: ${navigation: start_revid, revid, revid_list, pagesize, buttons, scan_url}, ${branch}, ${history} -->
+    <div class="bar" py:if="navigation is not None">
+        <!-- form must go OUTSIDE the table, or safari will add extra padding :( -->
         <form action="${branch.url('/changes', start_revid=getattr(navigation, 'start_revid', None),
-              file_id=getattr(navigation, 'file_id', None))}"><table><tr>
-            <td><span class="buttons">
-                <!-- ! navbar buttons never change, from now on.  i decree it! -->
-                <a href="${branch.context_url('/changes', clear=1)}"> changes </a>
-                <a href="${branch.context_url('/files', clear=1)}"> files </a>
-                <span class="search"> search: <input type="text" name="q" /> </span>
+              file_id=getattr(navigation, 'file_id', None))}"><table><tr>
+            <td><span class="buttons">
+                <!-- ! navbar buttons never change, from now on.  i decree it! -->
+                <a href="${branch.url('/changes', **util.get_context(clear=1))}"> changes </a>
+                <a href="${branch.url('/files', **util.get_context(clear=1))}"> files </a>
+                <span class="search"> search: <input type="text" name="q" /> </span>
             </span></td>
-            <td align="right" py:if="hasattr(navigation, 'revid_list')">
-                <span py:if="hasattr(navigation, 'feed')" class="rbuttons feed">
+            <td align="right" py:if="hasattr(navigation, 'revid_list')">
+                <span py:if="hasattr(navigation, 'feed')" class="rbuttons feed">
                     <a href="${branch.url('/atom')}">
-                    <img src="${tg.url('/static/images/feed-icon-16x16.gif')}" /></a>
-                </span>
-                <span class="navbuttons">
+                    <img src="${tg.url('/static/images/feed-icon-16x16.gif')}" /></a>
+                </span>
+                <span class="navbuttons">
                 	<span py:if="navigation.prev_page_revid">
                 	<a href="${navigation.prev_page_url}" title="Previous page"> &#171; </a>
-                    </span>
-                	<span py:if="not navigation.prev_page_revid"> &#171; </span>
+                    </span>
+                	<span py:if="not navigation.prev_page_revid"> &#171; </span>
                     revision ${history.get_revno(revid)}
-                    (<span py:if="navigation.pagesize > 1">page </span>${navigation.page_position} / ${navigation.page_count})
+                    (<span py:if="navigation.pagesize > 1">page </span>
+                    ${navigation.page_position} / ${navigation.page_count})
                 	<span py:if="navigation.next_page_revid">
                     <a href="${navigation.next_page_url}" title="Next page"> &#187; </a>
-                    </span>
-                	<span py:if="not navigation.next_page_revid"> &#187; </span>
-                </span>
+                    </span>
+                	<span py:if="not navigation.next_page_revid"> &#187; </span>
+                </span>
             </td>
-        </tr></table></form>
-    </div>
-</span>
-
+        </tr></table></form>
+    </div>
+</span>
+
 <span py:def="revision_link(revid, text, **overrides)" py:strip="True">
     <a title="Show revision ${history.get_revno(revid)}"
        href="${branch.url([ '/revision', revid ], **util.get_context(**overrides))}"> ${text} </a>
 </span>
 
-
-<!-- ! expand button functions: -->
-
-	<span py:strip="True" py:def="use_collapse_buttons()">
-		<!-- this is totally matty's fault.  i don't like javacsript. ;) -->
-		<script type="text/javascript" src="${tg.url('/static/javascript/collapse.js')}"></script>
-	</span>
-	
-	<span py:strip="True" py:def="collapse_all_button(group, normal='block')">
+
+<!-- ! expand button functions: -->
+
+	<span py:strip="True" py:def="use_collapse_buttons()">
+		<!-- this is totally matty's fault.  i don't like javacsript. ;) -->
+		<script type="text/javascript" src="${tg.url('/static/javascript/collapse.js')}"></script>
+	</span>
+	
+	<span py:strip="True" py:def="collapse_all_button(group, normal='block')">
 	    <a class="hide-all collapse-${group}-hideall"
-	       href="javascript:collapseAllDisplay('${group}','none')">
+	       href="javascript:collapseAllDisplay('${group}','none')">
 	        <img src="${tg.url('/static/images/nav-small-down.gif')}"
 	             width="10" height="10" alt="collapse"
-	             class="collapse-triangle" />collapse all</a>
+	             class="collapse-triangle" />collapse all</a>
 	    <a class="hide-all collapse-${group}-showall"
-	       href="javascript:collapseAllDisplay('${group}','${normal}')">
+	       href="javascript:collapseAllDisplay('${group}','${normal}')">
 	        <img src="${tg.url('/static/images/nav-small-right.gif')}"
 	             width="10" height="10" alt="expand"
-	             class="collapse-triangle" />expand all</a>
-	</span>
-	
-	<span py:strip="True" py:def="collapse_button(group, name, normal='block')">
+	             class="collapse-triangle" />expand all</a>
+	</span>
+	
+	<span py:strip="True" py:def="collapse_button(group, name, normal='block')">
 	    <a href="javascript:collapseDisplay('${group}','${name}','none')"
-	       class="hide-button collapse-${group}-${name}-hide" title="collapse">
+	       class="hide-button collapse-${group}-${name}-hide" title="collapse">
 	        <img src="${tg.url('/static/images/nav-small-down.gif')}"
 	             width="10" height="10" alt="collapse"
-	             class="collapse-triangle" />
-	    </a>
+	             class="collapse-triangle" />
+	    </a>
 	    <a href="javascript:collapseDisplay('${group}','${name}','${normal}')"
-	       class="show-button collapse-${group}-${name}-show" title="expand">
+	       class="show-button collapse-${group}-${name}-show" title="expand">
 	    	<img src="${tg.url('/static/images/nav-small-right.gif')}"
 	    	     witdh="10" height="10" alt="expand"
-	    	     class="collapse-triangle" />
-	    </a>
-	</span>
-
-</head>
-
+	    	     class="collapse-triangle" />
+	    </a>
+	</span>
+
+</head>
+
 <body py:match="item.tag=='{http://www.w3.org/1999/xhtml}body'"
-      py:attrs="item.items()">
-
-    <div py:replace="[item.text]+item[:]"/>
-
-	<!-- End of main_content -->
-	
-	<div class="footer">
+      py:attrs="item.items()">
+
+    <div py:replace="[item.text]+item[:]"/>
+
+	<!-- End of main_content -->
+	
+	<div class="footer">
 	    <span class="banner"><a href="http://www.bazaar-vcs.org/">
-	    <img src="${tg.url('/static/images/bazaar-banner.png')}" /></a></span>
+	    <img src="${tg.url('/static/images/bazaar-banner.png')}" /></a></span>
 	    <span class="banner"><a href="http://www.lag.net/loggerhead/">
-	    <img src="${tg.url('/static/images/loggerhead-banner.png')}" /></a></span>
-	</div>
-</body>
-
-</html>
+	    <img src="${tg.url('/static/images/loggerhead-banner.png')}" /></a></span>
+	</div>
+</body>
+
+</html>

=== modified file 'loggerhead/templates/revision.kid'
--- loggerhead/templates/revision.kid	2008-04-18 00:00:58 +0000
+++ loggerhead/templates/revision.kid	2007-06-26 06:28:36 +0000
@@ -17,33 +17,24 @@
     <span py:replace="use_collapse_buttons()"></span>
     
     <script type="text/javascript"> <!--
-    function show_sbs(path) {
+    function show_sbs() {
         collapseDisplay('style', 'sbs', 'table');
         collapseDisplay('style', 'unified', 'none');
-        document.cookie='diff=sbs; path=' + path; 
+        document.cookie='diff=sbs';
     }
-    function show_unified(path) {
+    function show_unified() {
         collapseDisplay('style', 'unified', 'table');
         collapseDisplay('style', 'sbs', 'none');
-        document.cookie='diff=unified; path=' + path; 
+        document.cookie='diff=unified'; 
     }
-    function load(path) {
+    function load() {
         sortCollapseElements();
-        if (document.cookie.indexOf('diff=unified') >= 0) {
-            show_unified(path);
-        }
-        if (document.cookie.indexOf('stop=1') >= 0) {
-            return;
-        }
-        if (document.cookie.indexOf('diff=unified') >= 0) {
-            window.location.hash = window.location.hash;
-            document.cookie='stop=1; max-age=5; path=' + window.location.pathname;
-        } 
+        if (document.cookie.indexOf('diff=unified') >= 0) { show_unified(); }
     }
     // --> </script>
 </head>
 
-<body onload="javascript:load('${branch.url('/')}')">
+<body onload="javascript:load()">
 
 ${navbar()}
 
@@ -51,27 +42,32 @@
     <span py:if="compare_revid is not None"> (compared to revision ${history.get_revno(compare_revid)}) </span>
     
     <div class="links">
-        <div> <b>&#8594;</b> <a href="${branch.context_url([ '/files', revid ])}">
-            browse files at revision ${change.revno} </a> </div>
-        <div> <b>&#8594;</b> <a href="${branch.context_url('/changes', start_revid=revid)}">
-            view history from revision ${change.revno} </a> </div>
+        <div> <b>&#8594;</b> <a href="${branch.url([ '/files', revid ], **util.get_context())}">
+            browse files</a> </div>
+        <div> <b>&#8594;</b> <a href="${branch.url('/changes', **util.get_context(start_revid=revid))}">
+            view branch changes</a> </div>
+        <span py:if="compare_revid is None" py:strip="True">
+            <div> <b>&#8594;</b> <a href="${branch.url([ '/bundle', revid, 'bundle.txt' ])}">
+                view/download patch</a> </div>
+        </span>
         <span py:if="compare_revid is not None" py:strip="True">
             <div> <b>&#8594;</b> <a href="${branch.url([ '/bundle', revid, compare_revid, 'bundle.txt' ])}">
-                download bundle from ${history.get_revno(compare_revid)} to ${change.revno} </a> </div>
+                view/download patch</a> </div>
         </span>
-        <span py:if="(remember is not None) and (compare_revid is None) and (revid != remember)" py:strip="True">
-            <div> <b>&#8594;</b> <a href="${branch.context_url([ '/revision', revid ], compare_revid=remember)}">
+        <span py:if="(remember is not None) and (compare_revid is None)" py:strip="True">
+            <div> <b>&#8594;</b> <a href="${branch.url([ '/revision', revid ],
+                **util.get_context(compare_revid=remember))}">
                 compare with revision ${history.get_revno(remember)} </a></div>
         </span>
         <span py:if="remember != revid" py:strip="True">
-            <div> <b>&#8594;</b> <a href="${branch.context_url([ '/revision', revid ], remember=revid, compare_revid=None)}">
+            <div> <b>&#8594;</b> <a href="${branch.url([ '/revision', revid ],
+                **util.get_context(remember=revid, compare_revid=None))}">
                 compare with another revision </a></div>
         </span>
         <span py:if="compare_revid is not None" py:strip="True">
-            <div> <b>&#8594;</b> <a href="${branch.context_url([ '/revision', compare_revid ], remember=revid, compare_revid=revid)}">
-                reverse the comparison (${change.revno} to ${history.get_revno(compare_revid)})</a></div>
-            <div> <b>&#8594;</b> <a href="${branch.context_url([ '/revision', revid ], remember=None, compare_revid=None)}">
-                stop comparing with revision ${history.get_revno(compare_revid)} </a></div>
+            <div> <b>&#8594;</b> <a href="${branch.url([ '/revision', revid ],
+                **util.get_context(remember=None, compare_revid=None))}">
+                stop comparing to revision ${history.get_revno(compare_revid)} </a></div>
         </span>
     </div>
 </h1>
@@ -84,7 +80,7 @@
         </tr>
         <tr>
             <th class="date">date:</th>
-            <td class="date"> ${util.date_time(change.date)} </td>
+            <td class="date"> ${change.date.strftime('%d %b %Y %H:%M')} </td>
         </tr>
 
         <tr py:if="len(change.merge_points) > 0">
@@ -130,44 +126,25 @@
         <tr py:if="change.changes.modified">
             <th class="files"> files modified: </th>
             <td class="files">
-              <span py:if="not show_plain_diffs" py:strip="True">
                 <span py:for="item in change.changes.modified" class="collapse-style-sbs-content">
                     <a href="#${item.filename}-s" class="filename" title="Jump to ${item.filename} below">${item.filename}</a><br />
                 </span>
                 <span py:for="item in change.changes.modified" class="collapse-style-unified-content">
                     <a href="#${item.filename}-u" class="filename" title="Jump to ${item.filename} below">${item.filename}</a><br />
                 </span>
-              </span>
-              <span py:if="show_plain_diffs" py:strip="True">
-                <span py:for="item in change.changes.modified" py:strip="True">
-                    <a href="#${item.filename}" class="filename" title="Jump to ${item.filename} below">${item.filename}</a><br />
-                </span>
-              </span>
             </td>
         </tr>
     </table>
 </div>
 
-<div py:if="show_plain_diffs" py:strip="True">
-  Diff of ${line_count} lines is too long to display richly -- limit is ${line_count_limit} lines.
-
-  <pre class="diff-plain">
-    <span py:strip="True" py:for="item in change.changes.modified">
-      <a name="${item.filename}" />${item.raw_diff}
-    </span>
-  </pre>
-</div>
-
-<div py:if="change.changes.modified and not show_plain_diffs" py:strip="True">
-
 <table class="diff-option-buttons">
 <tr>
     <td> ${collapse_all_button('file', 'table-row')} </td>
 
     <td class="spacey">
-        <a href="javascript:show_sbs('${branch.url('/')}')" class="hide-all collapse-style-sbs-show" title="collapse">
+        <a href="javascript:show_sbs()" class="hide-all collapse-style-sbs-show" title="collapse">
             <img src="${tg.url('/static/images/nav-small-out.gif')}" width="22" height="10" class="collapse-triangle" />show side by side</a>
-        <a href="javascript:show_unified('${branch.url('/')}')" class="hide-all collapse-style-unified-show" title="expand">
+        <a href="javascript:show_unified()" class="hide-all collapse-style-unified-show" title="expand">
             <img src="${tg.url('/static/images/nav-small-in.gif')}" width="22" height="10" class="collapse-triangle" />show unified diff</a>
     </td>
     
@@ -181,7 +158,7 @@
 <!-- ! i'm not a big fan of embedding python code here, but the alternatives all seem to be worse -->
 <?python uniqs={}; ?>
 
-<div class="diff">
+<div class="diff" py:if="change.changes.modified">
     <!-- ! side-by-side diff -->
     <table class="diff-block collapse-style-sbs-content">
         <span py:strip="True" py:for="item in change.changes.modified">
@@ -256,7 +233,6 @@
 	</tr>
     </table>
 </div>
-</div>
 
 </body>
 </html>

=== modified file 'loggerhead/tests/test_corners.py'
--- loggerhead/tests/test_corners.py	2008-04-18 03:22:47 +0000
+++ loggerhead/tests/test_corners.py	2007-09-10 13:43:45 +0000
@@ -1,4 +1,3 @@
-import re
 import os
 
 import cherrypy
@@ -94,25 +93,3 @@
         # It's not much of an assertion, but we only really care about
         # "assert not crashed".
         assert 'myfilename' in cherrypy.response.body[0]
-
-    def test_revision_size_limit(self):
-        self.createBranch()
-        msg = 'a very exciting commit message'
-        self.addFileAndCommit('myfilename', msg)
-
-        file_in_branch = open(os.path.join(self.bzrbranch, 'myfilename'), 'w')
-        file_in_branch.write('\n'.join(['line']*100))
-        file_in_branch.close()
-        newrevid = self.tree.commit(message='touch 100 lines')
-
-        self.setUpLoggerhead()
-        cherrypy.root._config['line_count_limit'] = 50
-        testutil.create_request('/project/branch/revision/'+newrevid)
-
-        match = re.search(
-            'Diff of [0-9]+ lines is too long to display richly -- limit '
-            'is 50 lines\\.',
-            cherrypy.response.body[0]
-            )
-
-        assert match is not None

=== modified file 'loggerhead/tests/test_simple.py'
--- loggerhead/tests/test_simple.py	2008-03-04 22:01:33 +0000
+++ loggerhead/tests/test_simple.py	2007-09-07 18:46:20 +0000
@@ -84,7 +84,7 @@
     def test_index(self):
         testutil.create_request('/')
         link = '<a href="/project/branch">branch</a>'
-        assert link in cherrypy.response.body[0].lower()
+        assert link in cherrypy.response.body[0]
 
     def test_changes(self):
         testutil.create_request('/project/branch/changes')
@@ -128,7 +128,7 @@
     def test_index(self):
         testutil.create_request('/')
         link = '<a href="/project/branch">branch</a>'
-        assert link in cherrypy.response.body[0].lower()
+        assert link in cherrypy.response.body[0]
 
     def test_changes(self):
         testutil.create_request('/project/branch/changes')

=== modified file 'loggerhead/textindex.py'
--- loggerhead/textindex.py	2008-02-27 03:36:09 +0000
+++ loggerhead/textindex.py	2007-08-28 16:11:01 +0000
@@ -25,11 +25,14 @@
     - index: 3-letter substring -> list(revids)
 """
 
+import logging
 import os
 import re
+import threading
 import time
 
 from loggerhead import util
+from loggerhead.util import decorator
 from loggerhead.lockfile import LockFile
 from loggerhead.changecache import FakeShelf
 
@@ -62,17 +65,17 @@
     def __init__(self, history, cache_path):
         self.history = history
         self.log = history.log
-
+        
         if not os.path.exists(cache_path):
             os.mkdir(cache_path)
-
+        
         self._recorded_filename = os.path.join(cache_path, 'textindex-recorded.sql')
         self._index_filename = os.path.join(cache_path, 'textindex.sql')
-
+        
         # use a lockfile since the cache folder could be shared across different processes.
         self._lock = LockFile(os.path.join(cache_path, 'index-lock'))
         self._closed = False
-
+        
         self.log.info('Using search index; %d entries.', len(self))
 
     def _index(self):
@@ -80,10 +83,10 @@
 
     def _recorded(self):
         return FakeShelf(self._recorded_filename)
-
+    
     def _is_indexed(self, revid, recorded):
         return recorded.get(util.to_utf8(revid)) is not None
-
+        
     @with_lock
     def is_indexed(self, revid):
         recorded = self._recorded()
@@ -91,7 +94,7 @@
             return self._is_indexed(revid, recorded)
         finally:
             recorded.close()
-
+    
     @with_lock
     def __len__(self):
         recorded = self._recorded()
@@ -103,15 +106,15 @@
     @with_lock
     def close(self):
         self._closed = True
-
+    
     @with_lock
     def closed(self):
         return self._closed
-
+    
     @with_lock
     def flush(self):
         pass
-
+    
     @with_lock
     def full(self):
         recorded = self._recorded()
@@ -159,7 +162,7 @@
         finally:
             index.close(commit=True)
             recorded.close(commit=True)
-
+    
     @with_lock
     def find(self, text, revid_list=None):
         index = self._index()
@@ -167,12 +170,12 @@
             text = normalize_string(text)
             if len(text) < 3:
                 return []
-
+    
             total_set = None
             if revid_list is not None:
                 total_set = set(revid_list)
             seen_all = False
-
+            
             for i in xrange(len(text) - 2):
                 sub = text[i:i + 3]
                 revid_set = index.get(sub)
@@ -191,7 +194,7 @@
                     return []
         finally:
             index.close()
-
+        
         # tricky: if seen_all is True, one of the substring indices was ALL
         # (in other words, unindexed), so our results are actually a superset
         # of the exact answer.
@@ -201,7 +204,7 @@
         # we DON'T care, and if one of the substrings hit ALL, there's a small
         # chance that we'll give a few false positives.
         return total_set
-
+    
     def check_rebuild(self, max_time=3600):
         """
         check if there are any un-indexed revisions, and if so, index them.
@@ -238,3 +241,4 @@
             time.sleep(1)
         self.log.info('Search index completed.')
         self.flush()
+

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2008-03-10 04:22:42 +0000
+++ loggerhead/util.py	2007-06-25 06:44:52 +0000
@@ -17,8 +17,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-from elementtree import ElementTree as ET
-
 import base64
 import cgi
 import datetime
@@ -31,83 +29,53 @@
 import time
 import traceback
 
+import turbogears
+
 
 log = logging.getLogger("loggerhead.controllers")
 
-# Display of times.
-
-# date_day -- just the day
-# date_time -- full date with time
-#
-# displaydate -- for use in sentences
-# approximatedate -- for use in tables
-#
-# displaydate and approximatedate return an elementtree <span> Element
-# with the full date in a tooltip.
-
-def date_day(value):
-    return value.strftime('%Y-%m-%d')
-
-
-def date_time(value):
-    return value.strftime('%Y-%m-%d %T')
-
-
-def _displaydate(date):
-    delta = abs(datetime.datetime.now() - date)
-    if delta > datetime.timedelta(1, 0, 0):
-        # far in the past or future, display the date
-        return 'on ' + date_day(date)
-    return _approximatedate(date)
-
-
-def _approximatedate(date):
-    delta = datetime.datetime.now() - date
-    if abs(delta) > datetime.timedelta(1, 0, 0):
-        # far in the past or future, display the date
-        return date_day(date)
-    future = delta < datetime.timedelta(0, 0, 0)
-    delta = abs(delta)
-    days = delta.days
-    hours = delta.seconds / 3600
-    minutes = (delta.seconds - (3600*hours)) / 60
-    seconds = delta.seconds % 60
-    result = ''
-    if future:
-        result += 'in '
-    if days != 0:
-        amount = days
-        unit = 'day'
-    elif hours != 0:
-        amount = hours
-        unit = 'hour'
-    elif minutes != 0:
-        amount = minutes
-        unit = 'minute'
-    else:
-        amount = seconds
-        unit = 'second'
-    if amount != 1:
-        unit += 's'
-    result += '%s %s' % (amount, unit)
-    if not future:
-        result += ' ago'
-        return result
-
-
-def _wrap_with_date_time_title(date, formatted_date):
-    elem = ET.Element("span")
-    elem.text = formatted_date
-    elem.set("title", date_time(date))
-    return elem
-
-
-def approximatedate(date):
-    return _wrap_with_date_time_title(date, _approximatedate(date))
-
-
-def displaydate(date):
-    return _wrap_with_date_time_title(date, _displaydate(date))
+
+def timespan(delta):
+    if delta.days > 730:
+        # good grief!
+        return '%d years' % (int(delta.days // 365.25),)
+    if delta.days >= 3:
+        return '%d days' % delta.days
+    seg = []
+    if delta.days > 0:
+        if delta.days == 1:
+            seg.append('1 day')
+        else:
+            seg.append('%d days' % delta.days)
+    hrs = delta.seconds // 3600
+    mins = (delta.seconds % 3600) // 60
+    if hrs > 0:
+        if hrs == 1:
+            seg.append('1 hour')
+        else:
+            seg.append('%d hours' % hrs)
+    if delta.days == 0:
+        if mins > 0:
+            if mins == 1:
+                seg.append('1 minute')
+            else:
+                seg.append('%d minutes' % mins)
+        elif hrs == 0:
+            seg.append('less than a minute')
+    return ', '.join(seg)
+
+
+def ago(timestamp):
+    now = datetime.datetime.now()
+    return timespan(now - timestamp) + ' ago'
+
+
+def fix_year(year):
+    if year < 70:
+        year += 2000
+    if year < 100:
+        year += 1900
+    return year
 
 
 class Container (object):
@@ -120,7 +88,7 @@
                 setattr(self, key, value)
         for key, value in kw.iteritems():
             setattr(self, key, value)
-
+    
     def __repr__(self):
         out = '{ '
         for key, value in self.__dict__.iteritems():
@@ -175,7 +143,7 @@
         return '%s at %s' % (username, domains[-2])
     return '%s at %s' % (username, domains[0])
 
-
+    
 def triple_factors(min_value=1):
     factors = (1, 3)
     index = 0
@@ -193,10 +161,10 @@
     """
     given a position in a maximum range, return a list of negative and positive
     jump factors for an hgweb-style triple-factor geometric scan.
-
+    
     for example, with pos=20 and max=500, the range would be:
     [ -10, -3, -1, 1, 3, 10, 30, 100, 300 ]
-
+    
     i admit this is a very strange way of jumping through revisions.  i didn't
     invent it. :)
     """
@@ -304,7 +272,7 @@
         divisor = MEG
     else:
         divisor = KILO
-
+    
     dot = size % divisor
     base = size - dot
     dot = dot * 10 // divisor
@@ -312,7 +280,7 @@
     if dot >= 10:
         base += 1
         dot -= 10
-
+    
     out = str(base)
     if (base < 100) and (dot != 0):
         out += '.%d' % (dot,)
@@ -323,7 +291,7 @@
     elif divisor == GIG:
         out += 'G'
     return out
-
+    
 
 def fill_in_navigation(navigation):
     """
@@ -337,21 +305,21 @@
     navigation.count = len(navigation.revid_list)
     navigation.page_position = navigation.position // navigation.pagesize + 1
     navigation.page_count = (len(navigation.revid_list) + (navigation.pagesize - 1)) // navigation.pagesize
-
+    
     def get_offset(offset):
         if (navigation.position + offset < 0) or (navigation.position + offset > navigation.count - 1):
             return None
         return navigation.revid_list[navigation.position + offset]
-
+    
     navigation.prev_page_revid = get_offset(-1 * navigation.pagesize)
     navigation.next_page_revid = get_offset(1 * navigation.pagesize)
-
-    params = { 'filter_file_id': navigation.filter_file_id }
+    
+    params = { 'file_id': navigation.file_id }
     if getattr(navigation, 'query', None) is not None:
         params['q'] = navigation.query
     else:
         params['start_revid'] = navigation.start_revid
-
+        
     if navigation.prev_page_revid:
         navigation.prev_page_url = navigation.branch.url([ navigation.scan_url, navigation.prev_page_revid ], **get_context(**params))
     if navigation.next_page_revid:
@@ -434,11 +402,9 @@
 #         current location along the navigation path (while browsing)
 #     - starting revid (start_revid)
 #         the current beginning of navigation (navigation continues back to
-#         the original revision) -- this defines an 'alternate mainline'
-#         when the user navigates into a branch.
+#         the original revision) -- this may not be along the primary revision
+#         path since the user may have navigated into a branch
 #     - file_id
-#         the file being looked at
-#     - filter_file_id
 #         if navigating the revisions that touched a file
 #     - q (query)
 #         if navigating the revisions that matched a search query
@@ -455,8 +421,7 @@
 #         for re-ordering an existing page by different sort
 
 t_context = threading.local()
-_valid = ('start_revid', 'file_id', 'filter_file_id', 'q', 'remember',
-          'compare_revid', 'sort')
+_valid = ('start_revid', 'file_id', 'q', 'remember', 'compare_revid', 'sort')
 
 
 def set_context(map):
@@ -467,7 +432,7 @@
     """
     return a context map that may be overriden by specific values passed in,
     but only contains keys from the list of valid context keys.
-
+    
     if 'clear' is set, only the 'remember' context value will be added, and
     all other context will be omitted.
     """

=== modified file 'setup.py'
--- setup.py	2008-02-28 04:34:51 +0000
+++ setup.py	2007-03-26 06:09:27 +0000
@@ -15,8 +15,6 @@
     url=url,
     download_url=download_url,
     license=license,
-    maintainer="Michael Hudson",
-    maintainer_email="michael.hudson@canonical.com",
     
     install_requires = [
         "TurboGears >= 1.0b1",

=== modified file 'start-loggerhead.py'
--- start-loggerhead.py	2008-03-08 22:55:27 +0000
+++ start-loggerhead.py	2007-06-19 00:09:43 +0000
@@ -86,7 +86,7 @@
     
     turbogears.update_config(configfile="dev.cfg", modulename="loggerhead.config")
     
-    potential_overrides = [ ('server.socket_port', int), ('server.webpath', str), ('server.thread_pool', int), ('server.socket_host' ,str) ]
+    potential_overrides = [ ('server.socket_port', int), ('server.webpath', str), ('server.thread_pool', int) ]
     for key, keytype in potential_overrides:
         value = config.get(key, None)
         if value is not None:
@@ -111,9 +111,10 @@
     Root = Root(config)
     
     # re-index every 6 hours
+    
     index_freq = config.get('cache_rebuild_frequency', 6 * 3600)
     turbogears.scheduler.add_interval_task(initialdelay=1, interval=index_freq, action=Root._check_rebuild)
-
+    
     try:
         turbogears.start_server(Root)
     finally:

